#include "menu.h"

using namespace STDP;

void Menu::iniciarMenu(){
	int teclapulsada; //Variable que guarda la tecla recogida por stdp.getKey();
	do{
		mostrarCabecera();
		mostrarDecorado();
		do{
			teclapulsada=mostrarMenuPrincipal();
			mostrarAnimacion();

		}while(teclapulsada!=KSPACE && teclapulsada != KESCAPE);

		if(teclapulsada == KESCAPE)
			posicionMenu = 5;
		procesarSeleccion();
	}while(posicionMenu != 5);
}

void Menu::mostrarCabecera(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.clearScreen();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CCYAN, CBLACK);
	stdp.setCursor(9,3);
	stdp.writeStr("    __  ___ _              ___              __            __     ");
	stdp.setCursor(9,4);
    stdp.writeStr("   /  |/  /(_)___  ___ _  / _ | ___ _ ___  / /_ ___ _ ___/ /___ _");
    stdp.setCursor(9,5);
    stdp.writeStr("  / /|_/ // // _ \\/ _ `/ / __ |/ _ `// _ \\/ __// _ `// _  // _ `/");
    stdp.setCursor(9,6);
    stdp.writeStr(" /_/  /_//_//_//_/\\_,_/ /_/ |_|\\_, / \\___/\\__/ \\_,_/ \\_,_/ \\_,_/ ");
    stdp.setCursor(9,7);
    stdp.writeStr("                              /___/                              ");

	stdp.refreshScr();
}

void Menu::mostrarCabeceraOpciones(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.clearScreen();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CBLUE, CBLACK);

	stdp.setCursor(15,3);
	stdp.writeStr("	  ___             _                       ");
	stdp.setCursor(15,4);
	stdp.writeStr("	 / _ \\ _ __   ___(_) ___  _ __   ___  ___ ");
	stdp.setCursor(15,5);
	stdp.writeStr("	| | | | '_ \\ / __| |/ _ \\| '_ \\ / _ \\/ __|");
	stdp.setCursor(15,6);
	stdp.writeStr("	| |_| | |_) | (__| | (_) | | | |  __/\\__ \\");
	stdp.setCursor(15,7);
	stdp.writeStr("	 \\___/| .__/ \\___|_|\\___/|_| |_|\\___||___/");
	stdp.setCursor(15,8);
	stdp.writeStr("	      |_|                                 ");

	stdp.refreshScr();
}

void Menu::mostrarCabeceraInstrucciones(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.clearScreen();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CYELLOW, CBLACK);

	stdp.setCursor(4,3);
	stdp.writeStr("	.-..-..-..---..---..---. .-..-..---..---..-..----..-..-..---..---.");
	stdp.setCursor(4,4);
	stdp.writeStr("	| || .` | \\ \\ `| |'| |-< | || || |  | |  | || || || .` || |-  \\ \\ ");
	stdp.setCursor(4,5);
	stdp.writeStr("	`-'`-'`-'`---' `-' `-'`-'`----'`---'`---'`-'`----'`-'`-'`---'`---'");

	stdp.refreshScr();
}

void Menu::mostrarCabeceraRanking(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.clearScreen();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CBLUE, CBLACK);

	stdp.setCursor(15,3);
	stdp.writeStr("	________              ______ _____                ");
	stdp.setCursor(15,4);
	stdp.writeStr("	___  __ \\_____ __________  /____(_)_____________ _");
	stdp.setCursor(15,5);
	stdp.writeStr("	__  /_/ /  __ `/_  __ \\_  //_/_  /__  __ \\_  __ `/");
	stdp.setCursor(15,6);
	stdp.writeStr("	_  _, _// /_/ /_  / / /  ,<  _  / _  / / /  /_/ / ");
	stdp.setCursor(15,7);
	stdp.writeStr("	/_/ |_| \\__,_/ /_/ /_//_/|_| /_/  /_/ /_/_\\__, /  ");
	stdp.setCursor(15,8);
	stdp.writeStr("	                                         /____/   ");

	stdp.refreshScr();
}

void Menu::mostrarCabeceraLogros(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.clearScreen();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CCYAN, CBLACK);
	stdp.setCursor(4,3);
	stdp.writeStr("	:::        ::::::::   ::::::::  :::::::::   ::::::::   ::::::::  ");
	stdp.setCursor(4,4);
	stdp.writeStr("	:+:       :+:    :+: :+:    :+: :+:    :+: :+:    :+: :+:    :+: ");
	stdp.setCursor(4,5);
	stdp.writeStr("	+:+       +:+    +:+ +:+        +:+    +:+ +:+    +:+ +:+        ");
	stdp.setCursor(4,6);
	stdp.writeStr("	+#+       +#+    +:+ :#:        +#++:++#:  +#+    +:+ +#++:++#++ ");
	stdp.setCursor(4,7);
	stdp.writeStr("	+#+       +#+    +#+ +#+   +#+# +#+    +#+ +#+    +#+        +#+ ");
	stdp.setCursor(4,8);
	stdp.writeStr("	#+#       #+#    #+# #+#    #+# #+#    #+# #+#    #+# #+#    #+# ");
	stdp.setCursor(4,9);
	stdp.writeStr("	########## ########   ########  ###    ###  ########   ########  ");

	stdp.refreshScr();

}

void Menu::mostrarCabeceraLogrosDesbloqueados(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.clearScreen();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ABOLD, CWHITE, CBLACK);
	stdp.setCursor(8,1);
	stdp.writeStr("	.____                               ");
	stdp.setCursor(8,2);
	stdp.writeStr("	|    |    ____   ___________  ____  ");
	stdp.setCursor(8,3);
	stdp.writeStr("	|    |   /  _ \\ / ___\\_  __ \\/  _ \\ ");
	stdp.setCursor(8,4);
	stdp.writeStr("	|    |__(  <_> ) /_/  >  | \\(  <_> )");
	stdp.setCursor(8,5);
	stdp.writeStr("	|_______ \\____/\\___  /|__|   \\____/ ");
	stdp.setCursor(8,6);
	stdp.writeStr("	        \\/    /_____/               ");
	stdp.setCursor(8,7);
	stdp.writeStr("	    .___            ___.   .__                    ");
	stdp.setCursor(8,8);
	stdp.writeStr("	  __| _/____   _____\\_ |__ |  |   ____   ______   ");
	stdp.setCursor(8,9);
	stdp.writeStr("	 / __ |/ __ \\ /  ___/| __ \\|  |  /  _ \\ / ____/   ");
	stdp.setCursor(8,10);
	stdp.writeStr("	/ /_/ \\  ___/ \\___ \\ | \\_\\ \\  |_(  <_> < <_|  |   ");
	stdp.setCursor(8,11);
	stdp.writeStr("	\\____ |\\___  >____  >|___  /____/\\____/ \\__   | /\\");
	stdp.setCursor(8,12);
	stdp.writeStr("	     \\/    \\/     \\/     \\/                |__| \\/");

}

void Menu::mostrarDecorado(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.refreshScr();

	for(int i = 0; i < 80; i++){
		stdp.setCursor(i,0);
		stdp.writeChar('*');
		stdp.setCursor(i,23);
		stdp.writeChar('*');
	}

	for(int i = 0; i < 24; i++){
		stdp.setCursor(0,i);
		stdp.writeChar('*');
		stdp.setCursor(79,i);
		stdp.writeChar('*');
	}
	stdp.refreshScr();

}

void Menu::mostrarAnimacion(){
	if(posicionAnimacion>=208)
		posicionAnimacion=0;

	int posicionAnimacionTemporal1 = 0;
	int posicionAnimacionTemporal2 = 0;
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.refreshScr();

	posicionAnimacionTemporal1=posicionAnimacion;
	posicionAnimacionTemporal2=posicionAnimacion;

	if(posicionAnimacion < 80){
		while(posicionAnimacionTemporal1-8 >= 0){
			posicionAnimacionTemporal1-=8;
		}
		stdp.setCursor(posicionAnimacionTemporal2-1,0);
		stdp.writeChar('*');
		stdp.setCursor(posicionAnimacionTemporal2,0);
	}

	if(posicionAnimacion >= 80 && posicionAnimacion < 104){
		posicionAnimacionTemporal2 = posicionAnimacion -80;
		while(posicionAnimacionTemporal1-8 >= 0){
			posicionAnimacionTemporal1-=8;
		}
		stdp.setCursor(79,posicionAnimacionTemporal2-1);
		stdp.writeChar('*');
		stdp.setCursor(79,posicionAnimacionTemporal2);
	}

	if(posicionAnimacion >= 104 && posicionAnimacion < 184){
		posicionAnimacionTemporal2 = posicionAnimacion -104;
		while(posicionAnimacionTemporal1-8 >= 0){
			posicionAnimacionTemporal1-=8;
		}
		stdp.setCursor(79-posicionAnimacionTemporal2-1,23);
		stdp.writeChar('*');
		stdp.setCursor(79-posicionAnimacionTemporal2,23);
	}

	if(posicionAnimacion >= 184 && posicionAnimacion < 208){
		posicionAnimacionTemporal2 = posicionAnimacion -184;
		while(posicionAnimacionTemporal1-8 >= 0){
			posicionAnimacionTemporal1-=8;
		}
		stdp.setCursor(0,23-posicionAnimacionTemporal2-1);
		stdp.writeChar('*');
		stdp.setCursor(0,23-posicionAnimacionTemporal2);
	}

	if(posicionAnimacionTemporal1==0 || posicionAnimacionTemporal1==4)
		stdp.writeChar('|');
	if(posicionAnimacionTemporal1==1 || posicionAnimacionTemporal1==5)
		stdp.writeChar('/');
	if(posicionAnimacionTemporal1==2 || posicionAnimacionTemporal1==6)
		stdp.writeChar('-');
	if(posicionAnimacionTemporal1==3 || posicionAnimacionTemporal1==7)
		stdp.writeChar('\\');

	stdp.refreshScr();
	usleep(45000);
	mostrarDecorado();
	posicionAnimacion++;
}

int Menu::mostrarMenuPrincipal(){
	string opciones[6];
	opciones[0]="        Empezar";
	opciones[1]="     Instrucciones";
	opciones[2]="Ranking de puntuaciones";
	opciones[3]="        Logros";
	opciones[4]="       Opciones";
	opciones[5]="        Salida";

	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	int teclapresionada = stdp.getKey();

	if(teclapresionada == KUP && posicionMenu !=0)
		posicionMenu-=1;
	if(teclapresionada == KDOWN && posicionMenu != 5)
		posicionMenu+=1;


	stdp.setCursor(28,13);
	stdp.writeStr("                         ");
	stdp.setCursor(28,13);
	stdp.writeStr(opciones[posicionMenu].c_str());

	stdp.setCursor(28,12);
	stdp.writeStr("                         ");
	if(posicionMenu != 0){
		stdp.setColor(ANORMAL, CMAGENTA, CBLACK);
		stdp.setCursor(28,12);
		stdp.writeStr(opciones[posicionMenu-1].c_str());
	}

	stdp.setCursor(28,14);
	stdp.writeStr("                         ");
	if(posicionMenu != 5){
		stdp.setColor(ANORMAL, CMAGENTA, CBLACK);
		stdp.setCursor(28,14);
		stdp.writeStr(opciones[posicionMenu+1].c_str());
	}

	stdp.setColor(ANORMAL, CYELLOW, CBLACK);
	for(int i = 26; i < 53; i++){
		stdp.setCursor(i,11);
		stdp.writeChar('#');
		stdp.setCursor(i,15);
		stdp.writeChar('#');
	}

	for(int i = 11; i < 16; i++){
		stdp.setCursor(26,i);
		stdp.writeChar('#');
		stdp.setCursor(52,i);
		stdp.writeChar('#');

}
	stdp.refreshScr();
	return(teclapresionada);
}

int Menu::mostrarMenuJuego(){

	string opciones[2];

	opciones[0]="Maraton (original mode)";
	opciones[1]="   Crazy (item mode)";

	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	int teclapresionada = stdp.getKey();

	if(teclapresionada == KUP && posicionMenuJuego !=0)
		posicionMenuJuego-=1;
	if(teclapresionada == KDOWN && posicionMenuJuego != 1)
		posicionMenuJuego+=1;

	stdp.setCursor(28,13);
	stdp.writeStr("                         ");
	stdp.setCursor(28,13);
	stdp.writeStr(opciones[posicionMenuJuego].c_str());

	stdp.setCursor(28,12);
	stdp.writeStr("                         ");
	if(posicionMenuJuego != 0){
		stdp.setColor(ANORMAL, CMAGENTA, CBLACK);
		stdp.setCursor(28,12);
		stdp.writeStr(opciones[posicionMenuJuego-1].c_str());
	}

	stdp.setCursor(28,14);
	stdp.writeStr("                         ");
	if(posicionMenuJuego != 1){
		stdp.setColor(ANORMAL, CMAGENTA, CBLACK);
		stdp.setCursor(28,14);
		stdp.writeStr(opciones[posicionMenuJuego+1].c_str());
	}

	stdp.setColor(ANORMAL, CYELLOW, CBLACK);
	for(int i = 26; i < 52; i++){
		stdp.setCursor(i,11);
		stdp.writeChar('#');
		stdp.setCursor(i,15);
		stdp.writeChar('#');
	}

	for(int i = 11; i < 16; i++){
		stdp.setCursor(26,i);
		stdp.writeChar('#');
		stdp.setCursor(52,i);
		stdp.writeChar('#');

	}
	stdp.refreshScr();
	return(teclapresionada);

}

int Menu::mostrarMenuOpciones(){

	string opciones[4];

	opciones[0]=" Cargar datos";
	opciones[1]="Guardar  datos";
	opciones[2]=" Borrar datos";
	opciones[3]="     Atras";

	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	int teclapresionada = stdp.getKey();

	if(teclapresionada == KUP && posicionMenuOpciones !=0)
		posicionMenuOpciones-=1;
	if(teclapresionada == KDOWN && posicionMenuOpciones != 3)
		posicionMenuOpciones+=1;

	stdp.setCursor(32,13);
	stdp.writeStr("                         ");
	stdp.setCursor(32,13);
	stdp.writeStr(opciones[posicionMenuOpciones].c_str());

	stdp.setCursor(32,12);
	stdp.writeStr("                         ");
	if(posicionMenuOpciones != 0){
		stdp.setColor(ANORMAL, CMAGENTA, CBLACK);
		stdp.setCursor(32,12);
		stdp.writeStr(opciones[posicionMenuOpciones-1].c_str());
	}

	stdp.setCursor(32,14);
	stdp.writeStr("                         ");
	if(posicionMenuOpciones != 3){
		stdp.setColor(ANORMAL, CMAGENTA, CBLACK);
		stdp.setCursor(32,14);
		stdp.writeStr(opciones[posicionMenuOpciones+1].c_str());
	}

	stdp.setColor(ANORMAL, CYELLOW, CBLACK);
	for(int i = 26; i < 52; i++){
		stdp.setCursor(i,11);
		stdp.writeChar('#');
		stdp.setCursor(i,15);
		stdp.writeChar('#');
	}

	for(int i = 11; i < 16; i++){
		stdp.setCursor(26,i);
		stdp.writeChar('#');
		stdp.setCursor(52,i);
		stdp.writeChar('#');

	}
	stdp.refreshScr();
	return(teclapresionada);

}

int Menu::mostrarMenuRanking(int &teclapresionada){
	string opciones[2];
	opciones[0]="      Survival";
	opciones[1]="       Crazy";
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	teclapresionada = stdp.getKey();

	if(teclapresionada == KUP && posicionMenuRanking !=0)
		posicionMenuRanking-=1;
	if(teclapresionada == KDOWN && posicionMenuRanking != 1)
		posicionMenuRanking+=1;


	stdp.setCursor(30,13);
	stdp.writeStr("                         ");
	stdp.setCursor(30,13);
	stdp.writeStr(opciones[posicionMenuRanking].c_str());

	stdp.setCursor(30,12);
	stdp.writeStr("                         ");
	if(posicionMenuRanking != 0){
		stdp.setColor(ANORMAL, CMAGENTA, CBLACK);
		stdp.setCursor(30,12);
		stdp.writeStr(opciones[posicionMenuRanking-1].c_str());
	}

	stdp.setCursor(30,14);
	stdp.writeStr("                         ");
	if(posicionMenuRanking != 1){
		stdp.setColor(ANORMAL, CMAGENTA, CBLACK);
		stdp.setCursor(30,14);
		stdp.writeStr(opciones[posicionMenuRanking+1].c_str());
	}

	stdp.setColor(ANORMAL, CYELLOW, CBLACK);
	for(int i = 26; i < 53; i++){
		stdp.setCursor(i,11);
		stdp.writeChar('#');
		stdp.setCursor(i,15);
		stdp.writeChar('#');
	}

	for(int i = 11; i < 16; i++){
		stdp.setCursor(26,i);
		stdp.writeChar('#');
		stdp.setCursor(52,i);
		stdp.writeChar('#');
	}

	return (posicionMenuRanking);
}

int Menu::mostrarRanking(int posicionMenuRanking){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	int teclapresionada = stdp.getKey();
	char* puntuacionConvertida;
	puntuacionConvertida = new char[6];
	char* nivelConvertido;
	nivelConvertido = new char[6];

	stdp.setCursor(25,10);
	stdp.writeStr("Nombre   Puntuación   Nivel");

	for(int i = 0; i<10; i++){
		stdp.setCursor(25,11+i);
		for(int j = 0; j<3; j++)
			stdp.writeChar(ranking[posicionMenuRanking][i].nombre[j]);
		stdp.setCursor(34,11+i);
		sprintf(puntuacionConvertida,"%d",ranking[posicionMenuRanking][i].puntuacion);
		stdp.writeStr(puntuacionConvertida);
		stdp.setCursor(47,11+i);
		sprintf(nivelConvertido,"%d",ranking[posicionMenuRanking][i].nivel);
		stdp.writeStr(nivelConvertido);
	}
	stdp.refreshScr();
	return(teclapresionada);
}

int Menu::mostrarMenuLogros(){

	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	int teclapresionada = stdp.getKey();

	if(logros[0]==true){
		stdp.setCursor(9,12);
		stdp.setColor(ANORMAL,CGREEN, CBLACK);
		stdp.writeStr("Fuck yeah");
		stdp.setColor(ABOLD, CYELLOW, CBLACK);

	}
	else{
		stdp.setCursor(18,12);
		stdp.setColor(ANORMAL,CRED, CBLACK);
		stdp.writeChar('X');
		stdp.setColor(ANORMAL,CWHITE,CBLACK);
	}

	stdp.setCursor(20,12);
	stdp.writeStr("1 - Bebé Tamagotchi: consigue 2500 puntos");

	if(logros[1]==true){
		stdp.setCursor(9,13);
		stdp.setColor(ANORMAL,CGREEN, CBLACK);
		stdp.writeStr("Fuck yeah");
		stdp.setColor(ABOLD, CYELLOW, CBLACK);
	}
	else{
		stdp.setCursor(18,13);
		stdp.setColor(ANORMAL,CRED, CBLACK);
		stdp.writeChar('X');
		stdp.setColor(ANORMAL,CWHITE,CBLACK);
	}
	stdp.setCursor(20,13);
	stdp.writeStr("2 - Yao Ming: consigue 5000 puntos");

	if(logros[2]==true){
		stdp.setCursor(9,14);
		stdp.setColor(ANORMAL,CGREEN, CBLACK);
		stdp.writeStr("Fuck yeah");
		stdp.setColor(ABOLD, CYELLOW, CBLACK);
	}
	else{
		stdp.setCursor(18,14);
		stdp.setColor(ANORMAL,CRED, CBLACK);
		stdp.writeChar('X');
		stdp.setColor(ANORMAL,CWHITE,CBLACK);
	}
	stdp.setCursor(20,14);
	stdp.writeStr("3 - Hero: consigue 15000 puntos");

	if(logros[3]==true){
		stdp.setCursor(9,15);
		stdp.setColor(ANORMAL,CGREEN, CBLACK);
		stdp.writeStr("Fuck yeah");
		stdp.setColor(ABOLD, CYELLOW, CBLACK);
	}
	else{
		stdp.setCursor(18,15);
		stdp.setColor(ANORMAL,CRED, CBLACK);
		stdp.writeChar('X');
		stdp.setColor(ANORMAL,CWHITE,CBLACK);
	}
	stdp.setCursor(20,15);
	stdp.writeStr("4 - Oldfag: consigue 25000 puntos");

	if(logros[4]==true){

		stdp.setCursor(9,16);
		stdp.setColor(ANORMAL,CGREEN, CBLACK);
		stdp.writeStr("Fuck yeah");
		stdp.setColor(ABOLD, CYELLOW, CBLACK);
	}
	else{
		stdp.setCursor(18,16);
		stdp.setColor(ANORMAL,CRED, CBLACK);
		stdp.writeChar('X');
		stdp.setColor(ANORMAL,CWHITE,CBLACK);
	}
	stdp.setCursor(20,16);
	stdp.writeStr("5 - Chuck: consigue 50000 puntos");

	stdp.refreshScr();
	return(teclapresionada);

}

int Menu::mostrarMenuInstrucciones(){
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	int teclapresionada = stdp.getKey();

	if(posicionMenuInstrucciones == 0){

		stdp.setCursor(35,21);
		stdp.writeStr(">>>>>>");
		stdp.setCursor(2,10);
		stdp.writeStr("     Este juego se basa en conseguir alcanzar la otra orilla para pasar");
		stdp.setCursor(2,11);
		stdp.writeStr(" de nivel. En el campo hay minas, y en cada casilla donde Woody se encuentre,");
		stdp.setCursor(2,12);
		stdp.writeStr(" en cada momento, se dirá el número de minas que tendrá alrededor.");
		stdp.setCursor(2,14);
		stdp.writeStr("     Las teclas a usar son W,A,S y D como flechas de dirección, el");
		stdp.setCursor(2,15);
		stdp.writeStr(" Espacio para aceptar por los menús y ESC para salir y poner pausa");
		stdp.setCursor(2,17);
		stdp.writeStr("     Los récods y logros se guardarán al cerrar el programa en un archivo");
		stdp.setCursor(2,18);
		stdp.writeStr(" así que cuidado con cerrar el programa de forma indebida.");
		stdp.refreshScr();
	}

	else{
		stdp.setCursor(35,21);
		stdp.writeStr("<<<<<<");
		stdp.setCursor(2,10);
		stdp.writeStr("     Hay dos modos: Supervivencia y Locura. El primero es el simple");
		stdp.setCursor(2,11);
		stdp.writeStr(" y el segundo incluye objetos. Los objetos son una bombilla (encienden");
		stdp.setCursor(2,12);
		stdp.writeStr(" y apagan la luz cada vez que se cae en ellas), un cambiaminas (desordena");
		stdp.setCursor(2,14);
		stdp.writeStr(" las minas), una botella de whisky que hace que vayas mareado hasta");
		stdp.setCursor(2,15);
		stdp.writeStr(" caer en otra, una brújula que muestra las minas durante un segundo, y ");
		stdp.setCursor(2,17);
		stdp.writeStr(" un suceso tan tramáticoque hace apoptosis (muerte de neuronas) y borra el ");
		stdp.setCursor(2,18);
		stdp.writeStr(" rastro que has llevado.");
		stdp.setCursor(2,20);
		stdp.writeStr("                  Esto es el juego, así que ahora, ¡A JUGAR!");
		stdp.refreshScr();
	}
	return(teclapresionada);
}

void Menu::procesarSeleccion(){
	int teclapulsada=0;
	Juego juego;

	if(posicionMenu == 0){
		mostrarCabecera();
		mostrarDecorado();
		do{
			teclapulsada=mostrarMenuJuego();
			mostrarAnimacion();

		}while(teclapulsada!=KSPACE && teclapulsada!=KESCAPE);

		if(teclapulsada!=KESCAPE){
			juego.iniciarJuego(posicionMenuJuego);
			mostrarLogroDesbloqueado(juego);
			gestionarRanking(juego);

			mostrarCabeceraRanking();
			mostrarDecorado();
			do{
				teclapulsada=mostrarRanking(posicionMenuJuego);
				mostrarAnimacion();

			}while(teclapulsada!=KSPACE);
		}
	}
	else if(posicionMenu == 1){
		do{
		mostrarCabeceraInstrucciones();
		mostrarDecorado();
			do{
				teclapulsada=mostrarMenuInstrucciones();
				mostrarAnimacion();

			}while(teclapulsada!=KSPACE && teclapulsada!=KESCAPE && teclapulsada!=KRIGHT && teclapulsada!=KLEFT);
			if(teclapulsada == KRIGHT && posicionMenuInstrucciones != 1)
				posicionMenuInstrucciones++;
			if(teclapulsada == KLEFT && posicionMenuInstrucciones != 0)
				posicionMenuInstrucciones--;

		}while(teclapulsada!=KSPACE && teclapulsada!=KESCAPE);
		posicionMenuInstrucciones = 0;

	}
	else if(posicionMenu == 2){
		int posicionMenuRanking;
		mostrarCabeceraRanking();
		mostrarDecorado();
		do{
			posicionMenuRanking=mostrarMenuRanking(teclapulsada);
			mostrarAnimacion();

		}while(teclapulsada!=KSPACE && teclapulsada!=KESCAPE);


		if(teclapulsada==KSPACE){
			mostrarCabeceraRanking();
			mostrarDecorado();
			do{
				teclapulsada=mostrarRanking(posicionMenuRanking);
				mostrarAnimacion();

			}while(teclapulsada!=KSPACE && teclapulsada!=KESCAPE);
		}

	}
	else if(posicionMenu == 3){
		mostrarCabeceraLogros();
		mostrarDecorado();
		do{
			teclapulsada=mostrarMenuLogros();
			mostrarAnimacion();

		}while(teclapulsada!=KSPACE && teclapulsada!=KESCAPE);
	}
	else if(posicionMenu == 4){

		do{
			mostrarCabeceraOpciones();
			mostrarDecorado();
			do{
				teclapulsada=mostrarMenuOpciones();
				mostrarAnimacion();

			}while(teclapulsada!=KSPACE && teclapulsada != KESCAPE);

			if(teclapulsada == KESCAPE)
				posicionMenuOpciones=3;
			if(posicionMenuOpciones==0)
				cargarDatos();
			if(posicionMenuOpciones==1)
				guardarDatos();
			if(posicionMenuOpciones==2)
				borrarDatos();

		}while(posicionMenuOpciones != 3);

	}

	else if(posicionMenu == 5){
		guardarDatos();
	}
}

void Menu::mostrarLogroDesbloqueado(Juego juego){
	int posicionLogro=15;
	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.clearScreen();


	if(juego.getPuntuacion()>=2500){
		mostrarCabeceraLogrosDesbloqueados();
		logros[0]=true;
		stdp.setCursor(19,posicionLogro);
		stdp.setColor(AUNDERLINE,CGREEN, CBLACK);
		stdp.writeStr("-Has debloqueado el logro \"Bebe Tamagotchi\"");
		stdp.refreshScr();
		do{
		}while(stdp.getKey()!=KSPACE);
		posicionLogro++;
	}
	if(juego.getPuntuacion()>=5000){
		mostrarCabeceraLogrosDesbloqueados();
		logros[1]=true;
		stdp.setCursor(19,posicionLogro);
		stdp.setColor(AUNDERLINE,CGREEN, CBLACK);
		stdp.writeStr("-Has debloqueado el logro \"Yao Ming\"");
		stdp.refreshScr();
		do{
		}while(stdp.getKey()!=KSPACE);
		posicionLogro++;
	}
	if(juego.getPuntuacion()>=15000){
		mostrarCabeceraLogrosDesbloqueados();
		logros[2]=true;
		stdp.setCursor(19,posicionLogro);
		stdp.setColor(AUNDERLINE,CGREEN, CBLACK);
		stdp.writeStr("-Has debloqueado el logro \"Hero\"");
		stdp.refreshScr();
		do{
		}while(stdp.getKey()!=KSPACE);
		posicionLogro++;
	}
	if(juego.getPuntuacion()>=25000){
		mostrarCabeceraLogrosDesbloqueados();
		logros[3]=true;
		stdp.setCursor(19,posicionLogro);
		stdp.setColor(AUNDERLINE,CGREEN, CBLACK);
		stdp.writeStr("-Has debloqueado el logro \"Oldfag\"");
		stdp.refreshScr();
		do{
		}while(stdp.getKey()!=KSPACE);
		posicionLogro++;
	}
	if(juego.getPuntuacion()>=50000){
		mostrarCabeceraLogrosDesbloqueados();
		logros[4]=true;
		stdp.setCursor(19,posicionLogro);
		stdp.setColor(AUNDERLINE,CGREEN, CBLACK);
		stdp.writeStr("-Has debloqueado el logro \"Chuck\"");
		stdp.refreshScr();
		do{
		}while(stdp.getKey()!=KSPACE);
		posicionLogro++;
	}
}

void Menu::gestionarRanking(Juego juego){


	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	int teclapresionada=0;
	int posicionIniciales=0;
	int iniciales[3];
	iniciales[0]=65;
	iniciales[1]=65;
	iniciales[2]=65;
	int i = 10;
	bool check = 0;
	do{
		i--;
		if(ranking[posicionMenuJuego][i].puntuacion < juego.getPuntuacion()){
			if(i < 10-1)
				ranking[posicionMenuJuego][i+1] = ranking[posicionMenuJuego][i];
		}
		else{
			check = 1;
			i++;
		}
	}while(check == 0 && i > 0);

	if(i < 10){
		stdp.clearScreen();
		stdp.setCursor(16,11);
		stdp.writeStr("¡Has superado un record! Introduce tus iniciales:");

		stdp.setCursor(11,17);
		stdp.setColor(ANORMAL,CBLUE, CBLACK);
		stdp.writeStr("Mueve con las direcciones y cuando acabes, acepta con Space");
		stdp.setColor(ANORMAL, CGREEN, CBLACK);


		do{
			stdp.setCursor(38,13);
			stdp.writeChar(iniciales[0]);
			stdp.setCursor(39,13);
			stdp.writeChar(iniciales[1]);
			stdp.setCursor(40,13);
			stdp.writeChar(iniciales[2]);

			stdp.setCursor(38,14);
			stdp.writeStr("    ");
			stdp.setCursor(38+posicionIniciales,14);
			stdp.writeChar('^');

			do{
				teclapresionada=stdp.getKey();
			}while(teclapresionada!=KRIGHT && teclapresionada!=KLEFT && teclapresionada!=KUP && teclapresionada!=KDOWN && teclapresionada != KSPACE);

			if(teclapresionada==KRIGHT && posicionIniciales != 2)
				posicionIniciales++;
			if(teclapresionada==KLEFT && posicionIniciales != 0)
				posicionIniciales--;
			if(teclapresionada==KUP)
				if(iniciales[posicionIniciales] != 65)
					iniciales[posicionIniciales]--;
				else
					iniciales[posicionIniciales]=90;
			if(teclapresionada==KDOWN)
				if(iniciales[posicionIniciales] != 90)
					iniciales[posicionIniciales]++;
				else
					iniciales[posicionIniciales]=65;


		}while(teclapresionada!=KSPACE);
		ranking[posicionMenuJuego][i].nombre[posicionMenuJuego]=iniciales[posicionMenuJuego];
		ranking[posicionMenuJuego][i].nombre[1]=iniciales[1];
		ranking[posicionMenuJuego][i].nombre[2]=iniciales[2];
		ranking[posicionMenuJuego][i].puntuacion=juego.getPuntuacion();
		ranking[posicionMenuJuego][i].nivel=juego.getNivel();
	}

}

void Menu::guardarDatos(){

	string archivo[3];
	archivo[0]="savedata.txt";
	archivo[1]="data/ranking1.dat";
	archivo[2]="data/ranking2.dat";

	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	ofstream fbe;
	bool error;

	do{
		error = 0;
		fbe.open(archivo[1].c_str(),ios::out | ios::binary);

		if (fbe.is_open())
		{

				fbe.write((const char *)&ranking[0], sizeof(ranking[0]));
				fbe.close();
		}


		else{
			stdp.setColor(ANORMAL, CWHITE, CBLACK);
			stdp.setCursor(3,20);
			stdp.writeStr("No se ha podido abrir el archivo del ranking 1 (¿existe la carpeta 'data'?).");
			stdp.setCursor(3,21);
			stdp.writeStr("No se guardarán los datos.");
			stdp.refreshScr();
			error = 1;
			sleep(2);
			stdp.setCursor(3,20);
			stdp.writeStr("                                                                            ");
			stdp.setCursor(3,21);
			stdp.writeStr("                          ");

		}

		fbe.open(archivo[2].c_str(),ios::out | ios::binary);

		if (fbe.is_open())
		{


				fbe.write((const char *)&ranking[1], sizeof(ranking[1]));
				fbe.close();

		}


		else{
			stdp.setColor(ANORMAL, CWHITE, CBLACK);
			stdp.setCursor(3,20);
			stdp.writeStr("No se ha podido abrir el archivo del ranking 2 (¿existe la carpeta 'data'?).");
			stdp.setCursor(3,21);
			stdp.writeStr("No se guardarán los datos.");
			stdp.refreshScr();
			error = 1;
			sleep(2);
			stdp.setCursor(3,20);
			stdp.writeStr("                                                                            ");
			stdp.setCursor(3,21);
			stdp.writeStr("                          ");
		}


		ofstream fo;

		fo.open(archivo[0].c_str(),ios::out);
		if(fo.is_open())
		{
			fo << logros[0] << " " << logros[1] << " " << logros[2] << " " << logros[3] << " " << logros[4] << endl;
			fo.close();
		}

		else{
			stdp.setColor(ANORMAL, CWHITE, CBLACK);
			stdp.setCursor(3,20);
			stdp.writeStr("No se ha podido crear/abrir el archivo savedata.");
			stdp.setCursor(3,21);
			stdp.writeStr("No se guardarán los datos.");
			stdp.refreshScr();
			error = 1;
			sleep(2);
			stdp.setCursor(3,20);
			stdp.writeStr("                                                                                  ");
			stdp.setCursor(3,21);
			stdp.writeStr("                          ");
		}

	}while(error == 1);

	stdp.setColor(ANORMAL, CWHITE, CBLACK);
	stdp.setCursor(35,20);
	stdp.writeStr("Guardando...");
	stdp.refreshScr();
	stdp.writeStr("            ");
	sleep(2);

	stdp.setCursor(23,20);
	stdp.writeStr("Datos guardados satisfactoriamente");
	stdp.refreshScr();
	sleep(2);
}

void Menu::cargarDatos(){
	string archivo[3];
	archivo[0]="savedata.txt";
	archivo[1]="data/ranking1.dat";
	archivo[2]="data/ranking2.dat";


	StdPijo& stdp = StdPijo::p();

	stdp.init();
	stdp.setGlobalEscapeDelay(0);
	stdp.setColor(ANORMAL, CWHITE, CBLACK);

	ifstream fbl;
	bool error = 0;
	bool error1 = 0;
	bool error2 = 0;
	bool error3 = 0;
	char cargado = ' ';

	do{
		error = 0;
		fbl.open(archivo[1].c_str(),ios::in | ios::binary);
		if(fbl.is_open())
		{
			fbl.read((char *)&ranking[0], sizeof(ranking[0]));
			while (!fbl.eof())
			{
				fbl.read((char *)&ranking[0], sizeof(ranking[0]));
			}
			fbl.close();
		}

		else{
			stdp.setColor(ANORMAL, CWHITE, CBLACK);
			stdp.setCursor(3,20);
			stdp.writeStr("No se ha podido abrir el archivo del ranking 1 (¿existe la carpeta 'data'?).");
			stdp.setCursor(3,21);
			stdp.writeStr("No se cargarán los datos.");
			stdp.refreshScr();
			error = 1;
			error1 = 1;
			sleep(2);
			stdp.setCursor(3,20);
			stdp.writeStr("                                                                            ");
			stdp.setCursor(3,21);
			stdp.writeStr("                          ");

		}
		fbl.open(archivo[2].c_str(),ios::in | ios::binary);
		if(fbl.is_open())
		{
			fbl.read((char *)&ranking[1], sizeof(ranking[1]));
			while (!fbl.eof())
			{
				fbl.read((char *)&ranking[1], sizeof(ranking[1]));
			}
			fbl.close();
		}

		else{
			stdp.setColor(ANORMAL, CWHITE, CBLACK);
			stdp.setCursor(3,20);
			stdp.writeStr("No se ha podido abrir el archivo del ranking 2 (¿existe la carpeta 'data'?).");
			stdp.setCursor(3,21);
			stdp.writeStr("No se cargarán los datos.");
			stdp.refreshScr();
			error = 1;
			error2 = 1;
			sleep(2);
			stdp.setCursor(3,20);
			stdp.writeStr("                                                                            ");
			stdp.setCursor(3,21);
			stdp.writeStr("                          ");

		}


		ifstream fi;
		fi.open(archivo[0].c_str(),ios::in);
		if(fi.is_open())
		{
			fi >> logros[0];
			fi >> logros[1];
			fi >> logros[2];
			fi >> logros[3];
			fi >> logros[4];
			fi.close();
		}

		else{
			stdp.setColor(ANORMAL, CWHITE, CBLACK);
			stdp.setCursor(3,20);
			stdp.writeStr("No se ha podido abrir el archivo savedata.");
			stdp.setCursor(3,21);
			stdp.writeStr("No se guardarán los datos.");
			stdp.refreshScr();
			error = 1;
			error3 = 1;
			sleep(2);
			stdp.setCursor(3,20);
			stdp.writeStr("                                                                                  ");
			stdp.setCursor(3,21);
			stdp.writeStr("                          ");
		}

		if(error == 1){
			ofstream fbe;
			if(error1 == 1){
				fbe.open(archivo[1].c_str(),ios::out | ios::binary);
				if (fbe.is_open())
					fbe.close();
			}
			if(error2 == 1){
				fbe.open(archivo[2].c_str(),ios::out | ios::binary);
				if (fbe.is_open())
					fbe.close();
			}

			ofstream fo;
			if(error3 == 1){
				fo.open(archivo[0].c_str(),ios::out);
				if(fo.is_open())
					fo.close();
			}
		}


	}while(error == 1);

		stdp.setColor(ANORMAL, CWHITE, CBLACK);
		stdp.setCursor(35,20);
		stdp.writeStr("Cargando...");
		stdp.refreshScr();
		stdp.writeStr("            ");
		sleep(2);

		stdp.setCursor(23,20);
		stdp.writeStr("Datos cargados satisfactoriamente");
		stdp.refreshScr();
		sleep(2);
		stdp.setCursor(23,20);
		stdp.writeStr("                                 ");
		stdp.refreshScr();
		sleep(1);

}

void Menu::borrarDatos(){

	for(int i=0; i<5;i++){
		logros[i]=false;
	}

	for(int i =0; i<10; i++){
		for(int j = 0; j<3; j++){
		ranking[0][i].nombre[j]=65;
		ranking[1][i].nombre[j]=65;
		}

		ranking[0][i].puntuacion=0;
		ranking[1][i].puntuacion=0;

		ranking[0][i].nivel=0;
		ranking[1][i].nivel=0;

	}

	guardarDatos();

}
